# -*- encoding: utf-8 -*-
import numpy as np
from numpy.linalg import norm, solve
from sympy import *
import sys
from scipy.optimize import fsolve
from plot_contour import *

# TASK 2

def newton(f, x0, df, tol=1e-5, N=1000):
	r""" Newton method to compute the root of f.
	INPUT:
		f 			: Function
		x0			: Initial guess
		df 			: Jacobian of f
		tol 		: relative tolerance
		N 			: Maximum number of iterations

	OUTPUT: 
		x 			: root of F
		i  			: number of iterations used to compute x

	"""
	error = np.linalg.norm(f(x0))
	i=0
	x=x0

	################################################
	##											  ##
	##		TODO : Implement Newton-method		  ##
	##											  ##
	################################################

	return x, i

#TASK 3
def PrintResults(F, starts, DF, rtol = 1e-8, N= 1e4):
	r""" Function to compare fsolve and newton outputs.
		INPUT:
			F   		: Function to compute the root of;
			DF  		: Jacobian of F;
			starts 		: Initial guess(es)
			rtol		: relative tolerance
			N 			: Maximum number of iterations

		OUTPUT : 
			zeros       : Root of the function F, computed with newton()
	"""
	
	zeros = []
	for z in starts:
		
		#################################################
		##											   ##
		## 		TODO : Complete the output loop		   ##
		##											   ##
		#################################################
		sol = np.array([0, 0])

		print("Start: ", z)
		print("fsolve:", sol)
		xstar, anzahl_iterationen = newton(F, z, DF, rtol, N)
		print("Newton: [%.5f  %.5f]\nF(x, y) = [%.5f, %.5f]" % (xstar[0], xstar[1], *F(xstar)))
		print("Iterationen: %d" % anzahl_iterationen)
		print("------------------------")

	return zeros


if __name__ == '__main__':

	# TASK 1

	# TODO: replace next lines with the correct implementation

	# build Jacobi matrix for w= [x,y]
	DF = lambda w: np.array([[0, 0], [0, 0]])
	
	# build F for w = [x,y]
	F = lambda w: np.array([0, 0])


	# TASK 2
	# TODO: Complete function newton()

	# TASK 3

	# TODO: Find the initial guesses and complete function PrintResults.

	#zeros = PrintResults(F,starts,DF,1e-12,1e2)
	
	#PlotRoots(F,zeros)
